<!--供应商管理-->
<template>
  <div class="supplier">
    <div class="supplier-title">
      <P>实验室名称-已授权列表 </P>
      <p class="button-p reset-button-one" @click="backPage">返回</p>
    </div>
    <div class="supplier-page">
      <el-form :model="queryParams" ref="queryForm" style="margin-top:20px;" :inline="true" label-width="120">
        <el-form-item label="关键字" prop="name">
          <el-input
            v-model="queryParams.searchValue"
            placeholder="名称/联系人/联系方式"
            clearable
            maxLength="30"
            size="small"
          />
        </el-form-item>
        <el-form-item label="类别" prop="zgType" label-width="80px">
          <el-select v-model="queryParams.userType" placeholder="请选择" clearable size="small">
            <el-option label="学生" value="22" />
            <el-option label="教师" value="11" />
          </el-select>
        </el-form-item>
        <el-form-item label="授权时间段" prop="dateRange" style="margin-left:10px;">
          <el-date-picker
            :clearable="false"
            v-model="dateRange"
            size="small"
            style="width: 240px"
            value-format="yyyy-MM-dd HH:mm:ss"
            type="daterange"
            range-separator="-"
            start-placeholder="开始日期"
            end-placeholder="结束日期"
          ></el-date-picker>
        </el-form-item>

        <el-form-item>
          <p class="inquire-button-one" @click="handleQuery">查询</p>
          <p class="reset-button-one" @click="resetQuery">重置</p>
        </el-form-item>
        <el-form-item label="" prop="title" style="float: right">
          <p class="inquire-button-one"
             style="width: 120px;margin-left: 10px;"
             @click="handleClick('','','addStudent')"
             v-hasPermi="['airbottle:supplier:add']"
          ><i class="el-icon-plus"></i>新增学生授权</p>
          <p class="inquire-button-one"
             style="width: 120px;margin-left: 10px;"
             @click="handleClick('','','addTeacher')"
             v-hasPermi="['airbottle:supplier:add']"
          ><i class="el-icon-plus"></i>新增教职工授权</p>

        </el-form-item>
      </el-form>
      <el-table border v-loading="loading" :data="tableData">
        <el-table-column label="所属单位" align="left" prop="deptName"/>
        <el-table-column label="姓名" align="left" prop="nickName"></el-table-column>
        <el-table-column label="验证方式" align="left" prop="verifyMode"></el-table-column>
        <el-table-column label="类别" align="left" prop="userType"></el-table-column>
        <el-table-column label="授权时间" align="left" prop="verifyTime"></el-table-column>
        <el-table-column label="授权人" align="left" prop="verifyUser"></el-table-column>
        <el-table-column label="失效时间" align="left" prop="invalidTime">
          <template slot-scope="scope">
            <el-date-picker
              :picker-options="pickerOptions0"
              v-model="scope.row.invalidTime"
              value-format="yyyy-MM-dd"
              type="date"
              placeholder="请选择失效时间">
            </el-date-picker>
          </template>
        </el-table-column>
        <el-table-column label="操作" align="left" class-name="small-padding fixed-width" width="120">
          <template slot-scope="scope">
            <div class="button-box">
              <p class="table-min-button"
                 v-hasPermi="['bottle:usegasAuditRecord:list']"
                 @click="handleClick('',scope.row,'delete')"
              >删除</p>
            </div>

          </template>
        </el-table-column>
      </el-table>
      <div style="display: flex;height:32px;margin-top:15px;">
        <div style="flex:5;">
          <pagination :page-sizes="[20, 30, 40, 50]"
                      v-show="total>0"
                      :total="total"
                      style="margin:0;"
                      :page.sync="queryParams.pageNum"
                      :limit.sync="queryParams.pageSize"
                      @pagination="getList"
          />
        </div>
      </div>
      <div style="text-align: center;">
        <el-button class="color_ff back_one" style="width: 300px;" @click="loseTimeSubmitForm()">确定</el-button>
      </div>

    </div>
    <!--关联实验室弹框-->
    <el-dialog :title=dialogTitle @close="handleClose" :visible.sync="dialogVisible" width="80%">
      <el-form :model="dialogForm" ref="dialogForm" :inline="true" label-width="140px">
        <el-form-item label="关键字" prop="name" >
          <el-input
            v-model="dialogForm.searchValue"
            placeholder="请输入名称/联系方式"
            clearable
            size="small"
          />
        </el-form-item>
        <el-form-item label="所属单位" prop="deptId" label-width="80px">
          <el-select v-model="dialogForm.deptId" clearable placeholder="请选择学院">
            <el-option
              v-for="item in collegeOptions"
              :key="item.deptId"
              :label="item.deptName"
              :value="item.deptId">
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item>
          <p class="inquire-button-one" style="margin-left:20px;" @click="onSearch">查询</p>
          <p class="reset-button-one" style="margin-left:20px;" @click="resetForm">重置</p>
        </el-form-item>
      </el-form>
      <div class="btn_list">
        <i class="el-icon-warning"></i>
        <i>已选择 {{labWhiteJoinSubList.length}} 项目</i>
        <i @click="toggleSelection(dialogTable)">全选本页</i>
        <i></i>
        <i @click="toggleSelection()">清除选项</i>
      </div>
      <el-table ref="multipleTable"  border tooltip-effect="dark" :row-key="getRowKeys" :data="dialogTable"
                highlight-current-row @selection-change="handleSelectionChange" style="cursor: pointer;height:500px;">
        <el-table-column type="selection"  width="55" :reserve-selection="true" align="center"></el-table-column>
        <el-table-column label="所属单位" align="left" prop="deptName"/>
        <el-table-column label="姓名" align="left" prop="nickName" />
        <el-table-column label="导师" align="left" prop="tutorUserName" v-if="userType==1"/>
        <el-table-column label="专业" align="left" prop="major" v-if="userType==1"/>
        <el-table-column label="身份" align="left" prop="positionName" v-if="userType==2"/>
        <el-table-column label="验证方式" align="left" prop="verifyMode">
          <template slot-scope="scope">
            <el-select v-model="scope.row.verifyMode" @change="verifyModeFun()" clearable >
              <el-option
                v-for="item in verifyWayList"
                :key="item.key"
                :label="item.value"
                :value="item.key">
              </el-option>
            </el-select>
          </template>
        </el-table-column>
        <el-table-column label="失效时间" align="left" prop="invalidTime">
          <template slot-scope="scope">
            <el-date-picker
              @blur="invalidTimeFun(scope.row,$event)"
              :picker-options="pickerOptions0"
              v-model="scope.row.invalidTime"
              value-format="yyyy-MM-dd"
              type="date"
              placeholder="请选择失效时间">
            </el-date-picker>
          </template>
        </el-table-column>
      </el-table>
      <pagination :page-sizes="[20, 30, 40, 50]"
                  v-show="total>0"
                  :total="total"
                  :page.sync="dialogForm.pageNum"
                  :limit.sync="dialogForm.pageSize"
                  @pagination="getUserList"
      />
      <div class="configuration">
        <el-form  :model="configuration" ref="queryForm" :inline="true" v-if="unifyDeploy">
          <el-form-item label="验证方式:" prop="name">
            <el-select v-model="configuration.verifyMode" clearable >
              <el-option
                v-for="item in verifyWayList"
                :key="item.key"
                :label="item.value"
                :value="item.key">
              </el-option>
            </el-select>
          </el-form-item>
          <el-form-item label="失效时间:" prop="name">
            <el-date-picker
              :picker-options="pickerOptions0"
              v-model="configuration.invalidTime"
              value-format="yyyy-MM-dd"
              type="date"
              placeholder="请选择失效时间">
            </el-date-picker>
          </el-form-item>
        </el-form>
        <p :class="unifyDeploy?'add-button-one-120':'inquire-button-one'"  @click="unifyDeployFun()">{{unifyDeploy?'取消统一配置':'统一配置'}}</p>
        <el-button class="color_ff back_one" @click="submitForm()">确定</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listStudentUser, listTeacherUser } from '@/api/system/user_student'
import { listDepartments } from '@/api/system/dept'
import { AddImpowerHaikang, delUserHaikang, getHaikangQueryTypes, getHaikangUserList } from '@/api/laboratory/subject'

export default {
  name: "Approval",
  components: {

  },
  props:{
    pageData:{},
  },
  data() {
    return {
      loading:false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize:20,
        searchValue:'',
        userType:'',
        hardId:'',
        startTime:'',
        endTime:'',
      },
      total:0,
      tableData:[],
      oldTableData:[],
      dateRange:[],
      dialogForm:{
        pageNum: 1,
        pageSize: 20,
        searchValue:'',
        deptId:'',
      },
      dialogTitle:'选择学生',
      dialogVisible:false,
      collegeOptions:[],//学院
      labWhiteJoinSubList:[],
      dialogTable:[],
      radioList:[],
      userType:1,//判断是学生 1 教职工2
      verifyWayList:[],
      configuration:{
        invalidTime:'',
        verifyMode:'',
      },
      unifyDeploy:false,
      //提交
      form:{},
      // 设置只能选择当前日期及之后的日期
      pickerOptions0: {
        disabledDate(time) {
          return time.getTime() < Date.now() - 8.64e7;//如果没有后面的-8.64e7就是不可以选择今天的
        }
      },
    };


  },
  methods: {

      //弹出层表格里验证方式改变重新赋值
      verifyModeFun(){
        //通过改变数组数据刷新视图
        this.dialogTable.pop()
      },
      //弹出层表格里失效时间改变重新赋值
        invalidTimeFun(item,e){
          this.dialogTable.splice(1,0);

      },


    //获取当前日期
      getdate() {
        const dates = new Date()
        dates.setMonth(dates.getMonth() + 1)
        var pastMonth = dates.getMonth() + 1
        var pastDay = dates.getDate()
        if (pastMonth >= 1 && pastMonth <= 9) {
          pastMonth = '0' + pastMonth
        }
        if (pastDay >= 0 && pastDay <= 9) {
          pastDay = '0' + pastDay
        }
        const endDate = dates.getFullYear() + '-' + pastMonth + '-' + pastDay
        return endDate
      },
      //查询
      onSearch() {
        this.dialogForm.pageNo = 1;
        this.getUserList();
      },
      //重置
      resetForm() {
        this.dialogForm.searchValue = '';
        this.dialogForm.deptId = '';
        this.onSearch();
      },
      //统一配置
      unifyDeployFun(){
          this.unifyDeploy=!this.unifyDeploy
          if(this.unifyDeploy==false){
            this.configuration.invalidTime='';
            this.configuration.verifyMode='';
          }
      },
      getRowKeys(row) {
        return row.userId;   //指定row-key的一个标识
      },
      //监听关联记录弹窗关闭
      handleClose(){
        console.log('弹窗关闭');
        this.$refs.multipleTable.clearSelection();
        this.dialogForm.searchValue='';
        this.dialogForm.deptId='';
      },
      //取消选中
      toggleSelection(rows) {
        let _this=this;
        if (rows) {
          rows.forEach(row => {
            this.$refs.multipleTable.toggleRowSelection(row,true);
          });

        } else {
          this.$refs.multipleTable.clearSelection();
        }
      },
      //选中实验室
      handleSelectionChange(val){
        let _this=this;
        this.labWhiteJoinSubList=[];
        this.labWhiteJoinSubList=val;

      },

      handleClick(index,row,doType){
        let _this=this;
        if(doType=='addStudent'){//新增学生授权
          _this.unifyDeploy=false;
          _this.dialogVisible=true;
          _this.dialogTitle='选择学生';
          _this.userType=1;
          this.getUserList();
        }else if(doType=='addTeacher'){//新增教职工授权
          _this.unifyDeploy=false;
          _this.dialogVisible=true;
          _this.dialogTitle='选择教职工';
          _this.userType=2;
          this.getUserList();
        }else if(doType=='delete'){//删除
          let _this=this
          console.log(row)
          this.$confirm('是否确认删除['+row.nickName+']门禁授权?', "警告", {
            confirmButtonText: "确定",
            cancelButtonText: "取消",
            type: "warning"
          }).then(function() {
            delUserHaikang(row.id).then( response => {
              _this.msgSuccess("删除成功");
              _this.getList();
            });
          }).then(() => {
            _this.getList();

          }).catch(() => {});
        }
      },
      //获取学院列表
      listDepartments(){
        listDepartments().then(response => {
          this.collegeOptions = response.data;
        });
      },
      /** 弹框查询列表 */
      getUserList() {//type 1学生 2教职工
        let _this=this;
        this.loading = true;
        if(_this.userType==1){
          listStudentUser(this.addDateRange(this.dialogForm, this.dateRange)).then(response => {
              this.dialogTable = response.rows;
              this.total = response.total;
              this.loading = false;
              this.dialogTable.forEach(function(item) {
                  item.verifyMode='cardOrfaceOrPw'
                  item.invalidTime=_this.getdate()
              })
            }
          );
        }else if(_this.userType==2){
          listTeacherUser(this.addDateRange(this.dialogForm, this.dateRange)).then(response => {
              this.dialogTable = response.rows;
              this.total = response.total;
              this.loading = false;
              this.dialogTable.forEach(function(item) {
                item.verifyMode='cardOrfaceOrPw'
                item.invalidTime=_this.getdate()
              })
            }
          );

        }
      },
      /** 查询门禁授权类型 */
      getHaikangQueryTypes(){
        getHaikangQueryTypes().then(response => {
          if(response.code==200){
            this.verifyWayList=response.data
          }
        });
      },


      /** 弹框搜索按钮操作 */
      handleQuery() {
        this.queryParams.pageNum = 1;
        this.getList();
      },
      /** 弹框重置按钮操作 */
      resetQuery() {
        this.dateRange=[];
        this.queryParams.searchValue = "";
        this.queryParams.userType = "";
        this.queryParams.startTime = "";
        this.queryParams.endTime = "";

        this.handleQuery();
      },
      //返回
      backPage(){
        this.$parent.handleClick('','','back');
        this.$parent.getList();
      },
      getList(){
        let _this=this;

        if(this.dateRange&&this.dateRange.length>0) {
          this.queryParams.startTime=this.dateRange[0]
          this.queryParams.endTime=this.dateRange[1]
        } else {
          this.queryParams.startTime=null;
          this.queryParams.endTime=null
        }
        getHaikangUserList(_this.queryParams).then( response => {
          let res=response.rows;
          _this.tableData=res;
          _this.oldTableData=res;
          _this.total=response.total;
        });
      },
    //失效时间修改后提交
      loseTimeSubmitForm(){
        let _this=this;
        let arr=[];
        // console.log(_this.oldTableData)
        // console.log( _this.tableData)
        // _this.oldTableData.forEach(function(item) {
        //
        // })
        _this.tableData.forEach(function(item2) {
          arr.push({'invalidTime':item2.invalidTime,'userId':item2.userId,'verifyMode':item2.verifyMode})
        })
        console.log(arr)
        _this.form.detailList=arr;
        setTimeout(function () {
          AddImpowerHaikang(_this.form).then(response => {
            if(response.code==200){
              _this.msgSuccess("修改成功");
              _this.getList();
            }
          });
        },100)
      },
      /* 新增授权*/
      submitForm(){
        let _this=this;
        let arr=[];
        console.log(this.labWhiteJoinSubList)
        if(this.labWhiteJoinSubList.length>0){
          if(_this.configuration.invalidTime && _this.configuration.verifyMode){//统一配置
            this.labWhiteJoinSubList.forEach(function(item){
              arr.push({'invalidTime':_this.configuration.invalidTime,'userId':item.userId,'verifyMode':_this.configuration.verifyMode})
            })
          }else{
            this.labWhiteJoinSubList.forEach(function(item){
              arr.push({'invalidTime':item.invalidTime,'userId':item.userId,'verifyMode':item.verifyMode})
            })
          }
          _this.form.detailList=arr;
          setTimeout(function () {
            AddImpowerHaikang(_this.form).then(response => {
              if(response.code==200){
                setTimeout(function () {
                  _this.msgSuccess("新增成功");
                  _this.dialogVisible=false;
                  _this.getList();
                },1000)
              }
            });
          },100)
        }else{
          this.msgError("请先选择人员!");
        }



      },
  },
  mounted() {
    this.queryParams.hardId=this.pageData.hardId;
    this.form.hardId=this.pageData.hardId;
    this.listDepartments();
    this.getHaikangQueryTypes()
    this.getList()
  }
};
</script>

<style lang="scss">
.supplier{
  flex:1;
  display: flex;
  flex-direction: column;
  /*顶部*/
  .supplier-title{
    display: flex;
    justify-content: space-between;
    align-items: center;
    border-bottom: 1px solid #E0E0E0;
    height: 90px;
    p:nth-child(1){
      line-height:60px;
      color: #0045AF;
      font-size:14px;
      margin:0 12px 0 20px;
    }
    p:nth-child(2){
      margin-right:20px;
    }
  }
  .supplier-page{
    flex:1;
    display: flex!important;
    flex-direction: column;
   // box-shadow: 0 0 8px 2px rgba(0, 0, 0, 0.1);
    padding:20px 20px 20px!important;
    border-radius:10px;
  }
  /*弹框*/
  .btn_list{
    width: 100%;
    height: 40px;
    background: rgba(1,131,250,0.1);
    border-radius: 6px;
    display: flex;
    justify-content: flex-start;
    align-items: center;
    margin-bottom: 32px;
    >i{
      font-style: normal;
      display: inline-block;
      cursor: pointer;
    }
    >i:nth-of-type(1){
      font-size: 20px;
      color: #0045AF;
      margin: 0 16px 0 14px;
    }
    >i:nth-of-type(2){
      font-size: 16px;
      font-family: Source Han Sans CN;
      font-weight: bold;
      color: #999999;
      line-height: 16px;
    }
    >i:nth-of-type(3){
      font-size: 16px;
      font-family: Source Han Sans CN;
      font-weight: bold;
      color: #0045AF;
      line-height: 16px;
      margin: 0 28px 0 46px;
    }
    >i:nth-of-type(4){
      font-size: 16px;
      font-family: Source Han Sans CN;
      font-weight: bold;
      color: #0045AF;
      line-height: 16px;
    }
    >i:nth-of-type(5){
      font-size: 16px;
      font-family: Source Han Sans CN;
      font-weight: bold;
      color: #FFA312;
      line-height: 16px;
      margin: 0 40px 0 28px;
    }
    .bottom-button-box{
      display: flex;
      width:220px;
      margin: 0;
      p{
        font-size:14px;
        height:30px;
        width:100px;
        line-height:30px;
        text-align: center;
        border-radius:4px;
      }
      p:nth-child(1){
        border:1px solid #E0E0E0;
        margin-right:20px;
      }
      p:nth-child(2){
        border:1px solid #0045AF;
      }
    }
  }
  .configuration{
    height: 70px;
    display: flex;
    justify-content: flex-end;
    align-items: center;
    border-top: 1px solid #D8D8D8;
    .el-form-item{
      margin-bottom: 0!important;
    }
  }
}
</style>
